#include <Servo.h>
#include <IBusBM.h>

#define motorW1_IN1 3
#define motorW1_IN2 4
#define motorW2_IN1 5
#define motorW2_IN2 6

Servo servoW1;
Servo servoW3;
Servo servoW4;
Servo servoW6;

IBusBM IBus;
IBusBM IBusSensor;

int ch0, ch1, ch2, ch3, ch6 = 0;
int r1=105;
int r3=100;
int r4=105;
int r6=60;
float speed1PWM= 0;

void setup() {

Serial.begin(115200);
IBus.begin(Serial1, IBUSBM_NOTIMER); // Servo iBUS
IBusSensor.begin(Serial2, IBUSBM_NOTIMER); // Sensor iBUS
IBusSensor.addSensor(IBUSS_INTV); // add voltage sensor
servoW1.attach(22);
servoW3.attach(23);
servoW4.attach(24);
servoW6.attach(25);

}

void loop() {

IBus.loop();
ch0 = IBus.readChannel(0); //채널 1  좌우방향
ch1 = IBus.readChannel(1); //채널 2  전진후진
ch2 = IBus.readChannel(2); //채널 3
ch3 = IBus.readChannel(3); //채널 4
ch6 = IBus.readChannel(6); //채널 7

servoW1.write(r1);
servoW3.write(r3);
servoW4.write(r4);
servoW6.write(r6);

if (ch0 > 1600)//우회전
{ 


 int R=map(ch1,1600,2000,30,50);
  servoW1.write(r1+40);
  servoW3.write(r3-40);

  servoW4.write(r4-40);
  servoW6.write(r6+40);
  delay(100);

 analogWrite(motorW1_IN1, 255);
 analogWrite(motorW1_IN2, 255);
 analogWrite(motorW2_IN1, 0);
 analogWrite(motorW2_IN2, 0);


}
else if (ch0 <1300)//좌회전
{
 int R=map(ch1,1600,2000,30,50);
  servoW1.write(r1+40);
  servoW3.write(r3-40);

  servoW4.write(r4-40);
  servoW6.write(r6+40);
  delay(100);

 analogWrite(motorW1_IN1, 0);
 analogWrite(motorW1_IN2, 0);
 analogWrite(motorW2_IN1, 255);
 analogWrite(motorW2_IN2, 255);
}

else if (ch1 > 1600) //전진
{
servoW1.write(r1);
servoW3.write(r3);
servoW4.write(r4);
servoW6.write(r6);
speed1PWM=map(ch1,1600,2000,0,255);

 analogWrite(motorW1_IN1, 0);
 analogWrite(motorW1_IN2, speed1PWM);
 analogWrite(motorW2_IN1, 0);
 analogWrite(motorW2_IN2, speed1PWM);
}

else if (ch1 < 1500) //후진
{
servoW1.write(r1);
servoW3.write(r3);
servoW4.write(r4);
servoW6.write(r6);

 speed1PWM=map(ch1,1500,1000,0,255);
  analogWrite(motorW1_IN1, speed1PWM);
  analogWrite(motorW1_IN2, 0);
  analogWrite(motorW2_IN1, speed1PWM);
  analogWrite(motorW2_IN2, 0);
}
else
{
servoW1.write(r1);
servoW3.write(r3);
servoW4.write(r4);
servoW6.write(r6);

analogWrite(motorW1_IN1, 0);
  analogWrite(motorW1_IN2, 0);
  analogWrite(motorW2_IN1, 0);
 analogWrite(motorW2_IN2, 0);
}

}
